diff -ruN vdr-1.7.17/PLUGINS/src/dvbhddevice/Makefile vdr-1.7.18/PLUGINS/src/dvbhddevice/Makefile
--- vdr-1.7.17/PLUGINS/src/dvbhddevice/Makefile	1970-01-01 01:00:00.000000000 +0100
+++ vdr-1.7.18/PLUGINS/src/dvbhddevice/Makefile	2011-04-17 13:40:55.000000000 +0200
@@ -0,0 +1,114 @@
+#
+# Makefile for a Video Disk Recorder plugin
+#
+# $Id: Makefile 1.7 2011/04/17 11:40:55 kls Exp $
+
+# The official name of this plugin.
+# This name will be used in the '-P...' option of VDR to load the plugin.
+# By default the main source file also carries this name.
+# IMPORTANT: the presence of this macro is important for the Make.config
+# file. So it must be defined, even if it is not used here!
+#
+PLUGIN = dvbhddevice
+
+### The version number of this plugin (taken from the main source file):
+
+VERSION = $(shell grep 'static const char \*VERSION *=' $(PLUGIN).c | awk '{ print $$6 }' | sed -e 's/[";]//g')
+
+### The C++ compiler and options:
+
+CXX      ?= g++
+CXXFLAGS ?= -g -O3 -Wall -Woverloaded-virtual -Wno-parentheses
+
+### The directory environment:
+
+VDRDIR = ../../..
+LIBDIR = ../../lib
+TMPDIR = /tmp
+
+### Make sure that necessary options are included:
+
+include $(VDRDIR)/Make.global
+
+### Allow user defined options to overwrite defaults:
+
+-include $(VDRDIR)/Make.config
+
+### The version number of VDR's plugin API (taken from VDR's "config.h"):
+
+APIVERSION = $(shell sed -ne '/define APIVERSION/s/^.*"\(.*\)".*$$/\1/p' $(VDRDIR)/config.h)
+
+### The name of the distribution archive:
+
+ARCHIVE = $(PLUGIN)-$(VERSION)
+PACKAGE = vdr-$(ARCHIVE)
+
+### Includes and Defines (add further entries here):
+
+INCLUDES += -I$(VDRDIR)/include
+
+DEFINES += -D_GNU_SOURCE -DPLUGIN_NAME_I18N='"$(PLUGIN)"'
+
+### The object files (add further files here):
+
+OBJS = $(PLUGIN).o bitbuffer.o dvbhdffdevice.o hdffcmd.o hdffosd.o setup.o
+
+### The main target:
+
+all: libvdr-$(PLUGIN).so i18n
+
+### Implicit rules:
+
+%.o: %.c
+	$(CXX) $(CXXFLAGS) -c $(DEFINES) $(INCLUDES) $<
+
+### Dependencies:
+
+MAKEDEP = $(CXX) -MM -MG
+DEPFILE = .dependencies
+$(DEPFILE): Makefile
+	@$(MAKEDEP) $(DEFINES) $(INCLUDES) $(OBJS:%.o=%.c) > $@
+
+-include $(DEPFILE)
+
+### Internationalization (I18N):
+
+PODIR     = po
+LOCALEDIR = $(VDRDIR)/locale
+I18Npo    = $(wildcard $(PODIR)/*.po)
+I18Nmsgs  = $(addprefix $(LOCALEDIR)/, $(addsuffix /LC_MESSAGES/vdr-$(PLUGIN).mo, $(notdir $(foreach file, $(I18Npo), $(basename $(file))))))
+I18Npot   = $(PODIR)/$(PLUGIN).pot
+
+%.mo: %.po
+	msgfmt -c -o $@ $<
+
+$(I18Npot): $(wildcard *.c)
+	xgettext -C -cTRANSLATORS --no-wrap --no-location -k -ktr -ktrNOOP --package-name=VDR --package-version=$(VDRVERSION) --msgid-bugs-address='<see README>' -o $@ $^
+
+%.po: $(I18Npot)
+	msgmerge -U --no-wrap --no-location --backup=none -q $@ $<
+	@touch $@
+
+$(I18Nmsgs): $(LOCALEDIR)/%/LC_MESSAGES/vdr-$(PLUGIN).mo: $(PODIR)/%.mo
+	@mkdir -p $(dir $@)
+	cp $< $@
+
+.PHONY: i18n
+i18n: $(I18Nmsgs) $(I18Npot)
+
+### Targets:
+
+libvdr-$(PLUGIN).so: $(OBJS)
+	$(CXX) $(CXXFLAGS) -shared $(OBJS) -o $@
+	@cp --remove-destination $@ $(LIBDIR)/$@.$(APIVERSION)
+
+dist: $(I18Npo) clean
+	@-rm -rf $(TMPDIR)/$(ARCHIVE)
+	@mkdir $(TMPDIR)/$(ARCHIVE)
+	@cp -a * $(TMPDIR)/$(ARCHIVE)
+	@tar czf $(PACKAGE).tgz -C $(TMPDIR) $(ARCHIVE)
+	@-rm -rf $(TMPDIR)/$(ARCHIVE)
+	@echo Distribution package created as $(PACKAGE).tgz
+
+clean:
+	@-rm -f $(OBJS) $(DEPFILE) *.so *.tgz core* *~ $(PODIR)/*.mo $(PODIR)/*.pot
diff -ruN vdr-1.7.17/PLUGINS/src/dvbhddevice/README vdr-1.7.18/PLUGINS/src/dvbhddevice/README
--- vdr-1.7.17/PLUGINS/src/dvbhddevice/README	1970-01-01 01:00:00.000000000 +0100
+++ vdr-1.7.18/PLUGINS/src/dvbhddevice/README	2011-04-17 13:20:22.000000000 +0200
@@ -0,0 +1,18 @@
+This is a "plugin" for the Video Disk Recorder (VDR).
+
+Written by:                  Andreas Regel <andreas.regel@gmx.de>
+
+Project's homepage:          http://powarman.dyndns.org/hg/dvbhddevice
+
+Latest version available at: http://powarman.dyndns.org/hg/dvbhddevice
+
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2 of the License, or
+(at your option) any later version.
+See the file COPYING for more information.
+
+Description:
+
+The 'dvbhddevice' plugin implements the output device for the
+"Full Featured TechnoTrend S2-6400" DVB cards.
diff -ruN vdr-1.7.17/PLUGINS/src/dvbhddevice/bitbuffer.c vdr-1.7.18/PLUGINS/src/dvbhddevice/bitbuffer.c
--- vdr-1.7.17/PLUGINS/src/dvbhddevice/bitbuffer.c	1970-01-01 01:00:00.000000000 +0100
+++ vdr-1.7.18/PLUGINS/src/dvbhddevice/bitbuffer.c	2009-12-29 15:29:20.000000000 +0100
@@ -0,0 +1,97 @@
+/*
+ * bitbuffer.c: TODO(short description)
+ *
+ * See the README file for copyright information and how to reach the author.
+ *
+ * $Id: bitbuffer.c 1.1 2009/12/29 14:29:20 kls Exp $
+ */
+
+#include "bitbuffer.h"
+#include <stdlib.h>
+
+cBitBuffer::cBitBuffer(uint32_t MaxLength)
+{
+    mData = NULL;
+    mMaxLength = 0;
+    mBitPos = 0;
+
+    if (MaxLength <= 0x10000)
+    {
+        mData = new uint8_t[MaxLength];
+        if (mData)
+        {
+            mMaxLength = MaxLength * 8;
+        }
+    }
+}
+
+cBitBuffer::~cBitBuffer(void)
+{
+    if (mData)
+        delete[] mData;
+}
+
+uint8_t * cBitBuffer::GetData(void)
+{
+    return mData;
+}
+
+uint32_t cBitBuffer::GetMaxLength(void)
+{
+    return mMaxLength / 8;
+}
+
+uint32_t cBitBuffer::GetBits(int NumBits)
+{
+    return 0;
+}
+
+void cBitBuffer::SetBits(int NumBits, uint32_t Data)
+{
+    uint32_t nextBitPos;
+    uint32_t bytePos;
+    uint32_t bitsInByte;
+    int shift;
+
+    if (NumBits <= 0 || NumBits > 32)
+        return;
+
+    nextBitPos = mBitPos + NumBits;
+
+    if (nextBitPos > mMaxLength)
+        return;
+
+    bytePos = mBitPos / 8;
+    bitsInByte = mBitPos % 8;
+
+    mData[bytePos] &= (uint8_t) (0xFF << (8 - bitsInByte));
+    shift = NumBits - (8 - bitsInByte);
+    if (shift > 0)
+        mData[bytePos] |= (uint8_t) (Data >> shift);
+    else
+        mData[bytePos] |= (uint8_t) (Data << (-shift));
+    NumBits -= 8 - bitsInByte;
+    bytePos++;
+    while (NumBits > 0)
+    {
+        shift = NumBits - 8;
+        if (shift > 0)
+            mData[bytePos] = (uint8_t) (Data >> shift);
+        else
+            mData[bytePos] = (uint8_t) (Data << (-shift));
+        NumBits -= 8;
+        bytePos++;
+    }
+    mBitPos = nextBitPos;
+}
+
+uint32_t cBitBuffer::GetByteLength(void)
+{
+    return (mBitPos + 7) / 8;
+}
+
+void cBitBuffer::SetDataByte(uint32_t Position, uint8_t Data)
+{
+    if (Position < mMaxLength)
+        mData[Position] = Data;
+}
diff -ruN vdr-1.7.17/PLUGINS/src/dvbhddevice/bitbuffer.h vdr-1.7.18/PLUGINS/src/dvbhddevice/bitbuffer.h
--- vdr-1.7.17/PLUGINS/src/dvbhddevice/bitbuffer.h	1970-01-01 01:00:00.000000000 +0100
+++ vdr-1.7.18/PLUGINS/src/dvbhddevice/bitbuffer.h	2009-12-29 15:27:03.000000000 +0100
@@ -0,0 +1,31 @@
+/*
+ * bitbuffer.h: TODO(short description)
+ *
+ * See the README file for copyright information and how to reach the author.
+ *
+ * $Id: bitbuffer.h 1.1 2009/12/29 14:27:03 kls Exp $
+ */
+
+#ifndef _HDFF_BITBUFFER_H_
+#define _HDFF_BITBUFFER_H_
+
+#include <stdint.h>
+
+class cBitBuffer
+{
+private:
+    uint8_t * mData;
+    uint32_t mMaxLength;
+    uint32_t mBitPos;
+public:
+    cBitBuffer(uint32_t MaxLength);
+    ~cBitBuffer(void);
+    uint8_t * GetData(void);
+    uint32_t GetMaxLength(void);
+    uint32_t GetBits(int NumBits);
+    void SetBits(int NumBits, uint32_t Data);
+    uint32_t GetByteLength(void);
+    void SetDataByte(uint32_t Position, uint8_t Data);
+};
+
+#endif
diff -ruN vdr-1.7.17/PLUGINS/src/dvbhddevice/dvbhddevice.c vdr-1.7.18/PLUGINS/src/dvbhddevice/dvbhddevice.c
--- vdr-1.7.17/PLUGINS/src/dvbhddevice/dvbhddevice.c	1970-01-01 01:00:00.000000000 +0100
+++ vdr-1.7.18/PLUGINS/src/dvbhddevice/dvbhddevice.c	2011-04-17 13:20:22.000000000 +0200
@@ -0,0 +1,48 @@
+/*
+ * dvbhddevice.c: A plugin for the Video Disk Recorder
+ *
+ * See the README file for copyright information and how to reach the author.
+ *
+ * $Id: dvbhddevice.c 1.12 2011/04/17 11:20:22 kls Exp $
+ */
+
+#include <vdr/plugin.h>
+#include "dvbhdffdevice.h"
+#include "setup.h"
+
+static const char *VERSION        = "0.0.3";
+static const char *DESCRIPTION    = "HD Full Featured DVB device";
+
+class cPluginDvbhddevice : public cPlugin {
+private:
+  cDvbHdFfDeviceProbe *probe;
+public:
+  cPluginDvbhddevice(void);
+  virtual ~cPluginDvbhddevice();
+  virtual const char *Version(void) { return VERSION; }
+  virtual const char *Description(void) { return DESCRIPTION; }
+  virtual cMenuSetupPage *SetupMenu(void);
+  virtual bool SetupParse(const char *Name, const char *Value);
+  };
+
+cPluginDvbhddevice::cPluginDvbhddevice(void)
+{
+  probe = new cDvbHdFfDeviceProbe;
+}
+
+cPluginDvbhddevice::~cPluginDvbhddevice()
+{
+  delete probe;
+}
+
+cMenuSetupPage *cPluginDvbhddevice::SetupMenu(void)
+{
+  return new cHdffSetupPage(cDvbHdFfDevice::GetHdffCmdHandler());
+}
+
+bool cPluginDvbhddevice::SetupParse(const char *Name, const char *Value)
+{
+  return gHdffSetup.SetupParse(Name, Value);
+}
+
+VDRPLUGINCREATOR(cPluginDvbhddevice); // Don't touch this!
